module Flytrap
  class Client
    def initialize(username, password, wsdl)
      Savon.configure do |config|
        config.log = false
      end

      @username = username
      @password = password
      @wsdl     = wsdl
    end

    def mc_issue_exists?(issue_id)
      client = Savon.client(@wsdl)
      response = client.request(:mc_issue_exists) do
        soap.body = {
          :username => username,
          :password => password,
          :issue_id => issue_id
        }
      end
      if response.success?
        return response.body[:mc_issue_exists_response][:return]
      end
    end

    def mc_issue_note_add(issue_id, note)
      client = Savon.client(@wsdl)
      response = client.request(:mc_issue_note_add) do
        soap.body = {
          :username => username,
          :password => password,
          :issue_id => issue_id,
          :note => { text: note }
        }
      end
      if response.success?
        return note_id = response.body[:mc_issue_note_add_response][:return]
      end
    end

    def mc_issue_add(project_id, project_name, category, summary, description)
      client = Savon.client(@wsdl)
      response = client.request(:mc_issue_add) do
        soap.body = {
          :username => username,
          :password => password,
          :issue => {
            :summary => summary,
            :project =>  { :id => project_id, :name => project_name },
            :category => category,
            :description => description
          }
        }
      end
      response
    end

    def mc_issue_get(issue_id)
      client = Savon.client(@wsdl)
      response = client.request(:mc_issue_get) do
        soap.body = {
          :username => username,
          :password => password,
          :issue_id => issue_id
        }
      end
      if response.success?
        return response.body[:mc_issue_get_response][:return]
      end
    end

    def mc_issue_get_id_from_summary(summary)
      client = Savon.client(@wsdl)
      response = client.request(:mc_issue_get_id_from_summary) do
        soap.body = {
          :username => username,
          :password => password,
          :summary => { text: summary[0..127] }
        }
      end
      if response.success?
        return response.body[:mc_issue_get_id_from_summary_response][:return]
      end
    end

    # We need these because Savon uses instance_eval for the request method
    # which means that we do not have access to our MantisConnect::Client's
    # instance variables within that block.
    private
    def username
      @username
    end

    def password
      @password
    end
  end
end
